<template>
  <st-content heading="Programas">
    <st-register v-model="dialog" @refreshData="refreshData" :key="componentKey"></st-register>
    <div class="content-body">
      <div class="table-heading">
        <st-search
          text="Buscar por nombre de código"
          @enter="search($event)"
        />
        <st-primary-btn
          nombre="Registrar Programa"
          @click="open"
        />
      </div>
      <st-data-table
        :dataInfo = "{ headers,items,key }"
        :dataPath = "path"
        :loading = "loading"
      />
    </div>
  </st-content>
</template>

<script>
import DataTable from '@/components/DataTable'
import Search from '@/components/Search'
import Register from '@/components/programs/Register'


export default {

  components:{
    'st-data-table': DataTable,
    'st-search': Search,
    'st-register': Register
  },
  data () {
    return{
      componentKey: 0,
      dialog:false,
      loading:false,
      path:{
        url: '/coordinador/programas/',
        id: 'idUnidad',
      },
      items:[],
      key:null,
      headers: [
      {
        text: 'Código',
        align: 'start',
        value: 'codigo',
      },
      {
        text: 'Nombre',
        value: 'nombre',
      },
      {
        text:'Coordinador',
        value:'coordinador.nombres',
      }
      ],

    }
  },
  methods:{
    async search(value){
      this.loading = true
      let { data: { data } } = await this.$api.getUnitsPrograms(this.$store.state.role.idUnit)

      this.items = data.programas
      this.loading = false
    },
    refreshData(response) {
      this.dialog=false;
      this.search('');
    },
    open(){
      this.dialog = true
      this.componentKey += 1; //forceRerender
    },
  },
  mounted() {
    this.search("");
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
  #cabecera{
    padding-top:50px;

  }

</style>
